package b4a.CustomKeyboardSample1;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.CustomKeyboardSample1", "b4a.CustomKeyboardSample1.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.CustomKeyboardSample1", "b4a.CustomKeyboardSample1.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.CustomKeyboardSample1.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _v7 = "";
public static int _type_text_flag_no_suggestions = 0;
public anywheresoftware.b4a.objects.EditTextWrapper _ettest = null;
public bm.watscho.keyboard.CustomKeyboard _v5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnshowevents = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchangekb = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
String _startkeyboard = "";
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"ckbtest\")";
mostCurrent._activity.LoadLayout("ckbtest",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="etTest.InputType = Bit.OR(etTest.InputType,TYPE_T";
mostCurrent._ettest.setInputType(anywheresoftware.b4a.keywords.Common.Bit.Or(mostCurrent._ettest.getInputType(),_type_text_flag_no_suggestions));
 //BA.debugLineNum = 45;BA.debugLine="etTest.SingleLine = False";
mostCurrent._ettest.setSingleLine(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 48;BA.debugLine="Dim StartKeyboard As String = \"nrkeyboard\"";
_startkeyboard = "nrkeyboard";
 //BA.debugLineNum = 49;BA.debugLine="Try";
try { //BA.debugLineNum = 50;BA.debugLine="CustKeyBoard.Initialize(\"CKB\", \"keyboardview\")'i";
mostCurrent._v5.Initialize(mostCurrent.activityBA,"CKB","keyboardview");
 //BA.debugLineNum = 51;BA.debugLine="CustKeyBoard.RegisterEditText(etTest, \"etTestD\",";
mostCurrent._v5.RegisterEditText((android.widget.EditText)(mostCurrent._ettest.getObject()),"etTestD",_startkeyboard,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e19) {
			processBA.setLastException(e19); //BA.debugLineNum = 53;BA.debugLine="Msgbox(\"There was an error in the 'Initialize/Re";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'Initialize/Register' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 54;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 56;BA.debugLine="CustKeyBoard.SetHapticFeedbackEnabled(True)";
mostCurrent._v5.SetHapticFeedbackEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 57;BA.debugLine="SetEditTextParams(StartKeyboard)";
_v6(_startkeyboard);
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 71;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
 //BA.debugLineNum = 72;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 //BA.debugLineNum = 73;BA.debugLine="If CustKeyBoard.IsSoftKeyboardVisible Then";
if (mostCurrent._v5.IsSoftKeyboardVisible()) { 
 //BA.debugLineNum = 74;BA.debugLine="If CustKeyBoard.HandleBack Then Return True";
if (mostCurrent._v5.HandleBack()) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 //BA.debugLineNum = 75;BA.debugLine="CustKeyBoard.HideKeyboard";
mostCurrent._v5.HideKeyboard();
 //BA.debugLineNum = 76;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 };
 //BA.debugLineNum = 79;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 67;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 61;BA.debugLine="If Not(CustKeyBoard.IsOScompatible) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._v5.IsOScompatible())) { 
 //BA.debugLineNum = 62;BA.debugLine="Msgbox(\"!!! This app needs at least APILEVEL 15,";
anywheresoftware.b4a.keywords.Common.Msgbox("!!! This app needs at least APILEVEL 15, the app ends now !!! ","CKBTEST-FAIL",mostCurrent.activityBA);
 //BA.debugLineNum = 63;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}
public static String  _btnchangekb_click() throws Exception{
String _newkeyboard = "";
 //BA.debugLineNum = 99;BA.debugLine="Sub btnChangeKb_Click";
 //BA.debugLineNum = 100;BA.debugLine="Dim NewKeyboard As String";
_newkeyboard = "";
 //BA.debugLineNum = 101;BA.debugLine="eventstring = eventstring & \"**** , \"";
_v7 = _v7+"**** , ";
 //BA.debugLineNum = 102;BA.debugLine="Select Case CustKeyBoard.GetRegisteredStatus(etTe";
switch (BA.switchObjectToInt(mostCurrent._v5.GetRegisteredStatus((android.widget.EditText)(mostCurrent._ettest.getObject())),"nrkeyboard","ipkeyboard","fullnrkeyboard","hexkeyboard","standard","neverregistered")) {
case 0:
 //BA.debugLineNum = 104;BA.debugLine="NewKeyboard = \"ipkeyboard\"";
_newkeyboard = "ipkeyboard";
 break;
case 1:
 //BA.debugLineNum = 106;BA.debugLine="NewKeyboard = \"fullnrkeyboard\"";
_newkeyboard = "fullnrkeyboard";
 break;
case 2:
 //BA.debugLineNum = 108;BA.debugLine="NewKeyboard = \"hexkeyboard\"";
_newkeyboard = "hexkeyboard";
 break;
case 3:
 //BA.debugLineNum = 110;BA.debugLine="NewKeyboard = \"standard\"";
_newkeyboard = "standard";
 break;
case 4:
 //BA.debugLineNum = 112;BA.debugLine="NewKeyboard = \"nrkeyboard\"";
_newkeyboard = "nrkeyboard";
 break;
case 5:
 //BA.debugLineNum = 114;BA.debugLine="NewKeyboard = \"neverregistered\"";
_newkeyboard = "neverregistered";
 break;
}
;
 //BA.debugLineNum = 116;BA.debugLine="Select Case NewKeyboard";
switch (BA.switchObjectToInt(_newkeyboard,"neverregistered")) {
case 0:
 break;
default:
 //BA.debugLineNum = 119;BA.debugLine="Try";
try { //BA.debugLineNum = 120;BA.debugLine="CustKeyBoard.ChangeKeyboardLayout(etTest,NewKe";
mostCurrent._v5.ChangeKeyboardLayout((android.widget.EditText)(mostCurrent._ettest.getObject()),_newkeyboard);
 } 
       catch (Exception e82) {
			processBA.setLastException(e82); //BA.debugLineNum = 122;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeybo";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyboardLayout' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 123;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 break;
}
;
 //BA.debugLineNum = 126;BA.debugLine="SetEditTextParams(NewKeyboard)";
_v6(_newkeyboard);
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public static String  _btnshowevents_click() throws Exception{
 //BA.debugLineNum = 129;BA.debugLine="Sub btnShowEvents_Click";
 //BA.debugLineNum = 130;BA.debugLine="Msgbox(eventstring, \"FIRED EVENTS\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_v7,"FIRED EVENTS",mostCurrent.activityBA);
 //BA.debugLineNum = 131;BA.debugLine="eventstring = \"\"";
_v7 = "";
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}
public static String  _ckb_heightchanged(int _newheight,int _oldheight) throws Exception{
 //BA.debugLineNum = 191;BA.debugLine="Sub CKB_HeightChanged(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 196;BA.debugLine="CallSubDelayed3(Me,\"SetEditTextHeight\",NewHeight,";
anywheresoftware.b4a.keywords.Common.CallSubDelayed3(mostCurrent.activityBA,main.getObject(),"SetEditTextHeight",(Object)(_newheight),(Object)(_oldheight));
 //BA.debugLineNum = 197;BA.debugLine="End Sub";
return "";
}
public static boolean  _ckb_keypressed(Object _viewtag,int _primarykeycode,int[] _addkeycodes) throws Exception{
String _tag = "";
int _codeshift = 0;
int _codemodechange = 0;
int _codecancel = 0;
int _codedone = 0;
int _codedelete = 0;
int _codealt = 0;
int _codeprev = 0;
int _codeallleft = 0;
int _codeleft = 0;
int _coderight = 0;
int _codeallright = 0;
int _codenext = 0;
int _codeclear = 0;
int _codeup = 0;
int _codedown = 0;
int _codereturn = 0;
int _starts = 0;
 //BA.debugLineNum = 209;BA.debugLine="Sub CKB_KeyPressed (ViewTag As Object, PrimaryKeyC";
 //BA.debugLineNum = 250;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 252;BA.debugLine="Dim CodeShift As Int = -1  		'Keyboard.KEYCODE_SH";
_codeshift = (int) (-1);
 //BA.debugLineNum = 253;BA.debugLine="Dim CodeModeChange As Int = -2  'Keyboard.KEYCODE";
_codemodechange = (int) (-2);
 //BA.debugLineNum = 254;BA.debugLine="Dim CodeCancel As Int = -3  	'Keyboard.KEYCODE_CA";
_codecancel = (int) (-3);
 //BA.debugLineNum = 255;BA.debugLine="Dim CodeDone As Int = -4  		'Keyboard.KEYCODE_DON";
_codedone = (int) (-4);
 //BA.debugLineNum = 256;BA.debugLine="Dim CodeDelete As Int = -5  	'Keyboard.KEYCODE_DE";
_codedelete = (int) (-5);
 //BA.debugLineNum = 257;BA.debugLine="Dim CodeAlt As Int = -6  		'Keyboard.KEYCODE_ALT";
_codealt = (int) (-6);
 //BA.debugLineNum = 260;BA.debugLine="Dim CodePrev As Int = 60000";
_codeprev = (int) (60000);
 //BA.debugLineNum = 261;BA.debugLine="Dim CodeAllLeft As Int = 60001";
_codeallleft = (int) (60001);
 //BA.debugLineNum = 262;BA.debugLine="Dim CodeLeft As Int = 60002";
_codeleft = (int) (60002);
 //BA.debugLineNum = 263;BA.debugLine="Dim CodeRight As Int = 60003";
_coderight = (int) (60003);
 //BA.debugLineNum = 264;BA.debugLine="Dim CodeAllRight As Int = 60004";
_codeallright = (int) (60004);
 //BA.debugLineNum = 265;BA.debugLine="Dim CodeNext As Int = 60005";
_codenext = (int) (60005);
 //BA.debugLineNum = 266;BA.debugLine="Dim CodeClear As Int = 60006";
_codeclear = (int) (60006);
 //BA.debugLineNum = 267;BA.debugLine="Dim CodeUp As Int = 60007";
_codeup = (int) (60007);
 //BA.debugLineNum = 268;BA.debugLine="Dim CodeDown As Int = 60008";
_codedown = (int) (60008);
 //BA.debugLineNum = 269;BA.debugLine="Dim CodeReturn As Int = 60009";
_codereturn = (int) (60009);
 //BA.debugLineNum = 271;BA.debugLine="Dim starts As Int";
_starts = 0;
 //BA.debugLineNum = 272;BA.debugLine="Select Case CustKeyBoard.GetRegisteredStatus(etTe";
switch (BA.switchObjectToInt(mostCurrent._v5.GetRegisteredStatus((android.widget.EditText)(mostCurrent._ettest.getObject())),"nrkeyboard","ipkeyboard","fullnrkeyboard","hexkeyboard")) {
case 0:
 //BA.debugLineNum = 274;BA.debugLine="eventstring = eventstring & \"NRKB_KP , \"";
_v7 = _v7+"NRKB_KP , ";
 //BA.debugLineNum = 275;BA.debugLine="If ((PrimaryKeyCode >= 0xE000) OR (PrimaryKeyCo";
if (((_primarykeycode>=0xe000) || (_primarykeycode<=0)) && (_primarykeycode<=0xf8ff)) { 
 //BA.debugLineNum = 277;BA.debugLine="starts = etTest.SelectionStart";
_starts = mostCurrent._ettest.getSelectionStart();
 //BA.debugLineNum = 278;BA.debugLine="Select Case PrimaryKeyCode";
switch (BA.switchObjectToInt(_primarykeycode,_codecancel,_codeleft,_coderight)) {
case 0:
 //BA.debugLineNum = 280;BA.debugLine="CustKeyBoard.InsertText(etTest,\"   bye-bye";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"   bye-bye  :-)"+" "+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (5000))),mostCurrent._ettest.getText().length());
 //BA.debugLineNum = 281;BA.debugLine="CustKeyBoard.HideKeyboard";
mostCurrent._v5.HideKeyboard();
 break;
case 1:
 //BA.debugLineNum = 283;BA.debugLine="If starts > 2 Then";
if (_starts>2) { 
 //BA.debugLineNum = 284;BA.debugLine="etTest.SelectionStart = starts-3";
mostCurrent._ettest.setSelectionStart((int) (_starts-3));
 }else {
 //BA.debugLineNum = 286;BA.debugLine="etTest.SelectionStart = 0";
mostCurrent._ettest.setSelectionStart((int) (0));
 };
 break;
case 2:
 //BA.debugLineNum = 289;BA.debugLine="If starts < (etTest.Text.Length - 3) Then";
if (_starts<(mostCurrent._ettest.getText().length()-3)) { 
 //BA.debugLineNum = 290;BA.debugLine="etTest.SelectionStart = starts + 3";
mostCurrent._ettest.setSelectionStart((int) (_starts+3));
 }else {
 //BA.debugLineNum = 292;BA.debugLine="etTest.SelectionStart = etTest.Text.Length";
mostCurrent._ettest.setSelectionStart(mostCurrent._ettest.getText().length());
 };
 break;
}
;
 //BA.debugLineNum = 295;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 298;BA.debugLine="Select Case PrimaryKeyCode";
switch (_primarykeycode) {
case 48:
 //BA.debugLineNum = 300;BA.debugLine="CustKeyBoard.InsertText(etTest,\"zero,\",CustK";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"zero,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 49:
 //BA.debugLineNum = 302;BA.debugLine="CustKeyBoard.InsertText(etTest,\"one,\",CustKe";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"one,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 50:
 //BA.debugLineNum = 304;BA.debugLine="CustKeyBoard.InsertText(etTest,\"two,\",CustKe";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"two,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 51:
 //BA.debugLineNum = 306;BA.debugLine="CustKeyBoard.InsertText(etTest,\"three, \",Cus";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"three, ",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 52:
 //BA.debugLineNum = 308;BA.debugLine="CustKeyBoard.InsertText(etTest,\"four,\",CustK";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"four,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 53:
 //BA.debugLineNum = 310;BA.debugLine="CustKeyBoard.InsertText(etTest,\"five,\",CustK";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"five,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 54:
 //BA.debugLineNum = 312;BA.debugLine="CustKeyBoard.InsertText(etTest,\"six,\",CustKe";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"six,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 55:
 //BA.debugLineNum = 314;BA.debugLine="CustKeyBoard.InsertText(etTest,\"seven,\",Cust";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"seven,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 56:
 //BA.debugLineNum = 316;BA.debugLine="CustKeyBoard.InsertText(etTest,\"eight,\",Cust";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"eight,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
case 57:
 //BA.debugLineNum = 318;BA.debugLine="CustKeyBoard.InsertText(etTest,\"nine,\",CustK";
mostCurrent._v5.InsertText((android.widget.EditText)(mostCurrent._ettest.getObject()),"nine,",mostCurrent._v5.GetSelectionStart((android.widget.EditText)(mostCurrent._ettest.getObject())));
 break;
}
;
 //BA.debugLineNum = 320;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 break;
case 1:
 //BA.debugLineNum = 323;BA.debugLine="eventstring = eventstring & \"IPKB_KP , \"";
_v7 = _v7+"IPKB_KP , ";
 //BA.debugLineNum = 324;BA.debugLine="Return False 'handled inside the library";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 2:
 //BA.debugLineNum = 326;BA.debugLine="eventstring = eventstring & \"FNRKB_KP , \"";
_v7 = _v7+"FNRKB_KP , ";
 //BA.debugLineNum = 327;BA.debugLine="Return False 'handled inside the library";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 3:
 //BA.debugLineNum = 329;BA.debugLine="eventstring = eventstring & \"HEXKB_KP , \"";
_v7 = _v7+"HEXKB_KP , ";
 //BA.debugLineNum = 330;BA.debugLine="Return False 'handled inside the library";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
default:
 //BA.debugLineNum = 332;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
}
;
 //BA.debugLineNum = 334;BA.debugLine="End Sub";
return false;
}
public static String  _ckb_onkeydown(Object _viewtag,int _primarykeycode) throws Exception{
String _tag = "";
 //BA.debugLineNum = 342;BA.debugLine="Sub CKB_onKeyDown(ViewTag As Object, PrimaryKeyCod";
 //BA.debugLineNum = 344;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 345;BA.debugLine="eventstring = eventstring & \"KB_KD , \"";
_v7 = _v7+"KB_KD , ";
 //BA.debugLineNum = 346;BA.debugLine="End Sub";
return "";
}
public static String  _ckb_onkeyup(Object _viewtag,int _primarykeycode) throws Exception{
String _tag = "";
 //BA.debugLineNum = 336;BA.debugLine="Sub CKB_onKeyUp(ViewTag As Object, PrimaryKeyCode";
 //BA.debugLineNum = 338;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 339;BA.debugLine="eventstring = eventstring & \"KB_KU , \"";
_v7 = _v7+"KB_KU , ";
 //BA.debugLineNum = 340;BA.debugLine="End Sub";
return "";
}
public static String  _ettestd_click() throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _et = null;
 //BA.debugLineNum = 166;BA.debugLine="Sub etTestD_Click()";
 //BA.debugLineNum = 170;BA.debugLine="Dim et As EditText = Sender";
_et = new anywheresoftware.b4a.objects.EditTextWrapper();
_et.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 171;BA.debugLine="eventstring = eventstring & \"ET_CL , \"";
_v7 = _v7+"ET_CL , ";
 //BA.debugLineNum = 172;BA.debugLine="End Sub";
return "";
}
public static String  _ettestd_focuschanged(boolean _hasfocus) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 //BA.debugLineNum = 153;BA.debugLine="Sub etTestD_FocusChanged (HasFocus As Boolean)";
 //BA.debugLineNum = 158;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 159;BA.debugLine="If HasFocus Then";
if (_hasfocus) { 
 //BA.debugLineNum = 160;BA.debugLine="eventstring = eventstring & \"ET_FCT , \"";
_v7 = _v7+"ET_FCT , ";
 }else {
 //BA.debugLineNum = 162;BA.debugLine="eventstring = eventstring & \"ET_FCF , \"";
_v7 = _v7+"ET_FCF , ";
 };
 //BA.debugLineNum = 164;BA.debugLine="End Sub";
return "";
}
public static boolean  _ettestd_handleaction() throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _et = null;
 //BA.debugLineNum = 180;BA.debugLine="Sub etTestD_HandleAction() As Boolean";
 //BA.debugLineNum = 186;BA.debugLine="Dim et As EditText = Sender";
_et = new anywheresoftware.b4a.objects.EditTextWrapper();
_et.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 187;BA.debugLine="eventstring = eventstring & \"ET_HA , \"";
_v7 = _v7+"ET_HA , ";
 //BA.debugLineNum = 188;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 189;BA.debugLine="End Sub";
return false;
}
public static String  _ettestd_textchanged(String _old,String _new) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _et = null;
 //BA.debugLineNum = 174;BA.debugLine="Sub etTestD_TextChanged (Old As String, New As Str";
 //BA.debugLineNum = 176;BA.debugLine="Dim et As EditText = Sender";
_et = new anywheresoftware.b4a.objects.EditTextWrapper();
_et.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 177;BA.debugLine="eventstring = eventstring & \"ET_TC , \"";
_v7 = _v7+"ET_TC , ";
 //BA.debugLineNum = 178;BA.debugLine="End Sub";
return "";
}
public static boolean  _ettestd_touch(int _action,float _x,float _y,Object _motionevent) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _et = null;
 //BA.debugLineNum = 134;BA.debugLine="Sub etTestD_Touch (Action As Int, X As Float, Y As";
 //BA.debugLineNum = 141;BA.debugLine="Dim et As EditText = Sender";
_et = new anywheresoftware.b4a.objects.EditTextWrapper();
_et.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 142;BA.debugLine="Select Action ' Selects the Action parameter";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 144;BA.debugLine="eventstring = eventstring & \"ET_TOD , \"";
_v7 = _v7+"ET_TOD , ";
 break;
case 1:
 break;
case 2:
 //BA.debugLineNum = 148;BA.debugLine="eventstring = eventstring & \"ET_TOU , \"";
_v7 = _v7+"ET_TOU , ";
 break;
}
;
 //BA.debugLineNum = 150;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 151;BA.debugLine="End Sub";
return false;
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 29;BA.debugLine="Dim etTest As EditText";
mostCurrent._ettest = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim CustKeyBoard As CustomKeyboard";
mostCurrent._v5 = new bm.watscho.keyboard.CustomKeyboard();
 //BA.debugLineNum = 31;BA.debugLine="Dim btnShowEvents As Button";
mostCurrent._btnshowevents = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim btnChangeKb As Button";
mostCurrent._btnchangekb = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim eventstring As String";
_v7 = "";
 //BA.debugLineNum = 22;BA.debugLine="Dim TYPE_TEXT_FLAG_NO_SUGGESTIONS  As Int = 0x800";
_type_text_flag_no_suggestions = (int) (0x80000);
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _setedittextheight(int _newheight,int _oldheight) throws Exception{
 //BA.debugLineNum = 199;BA.debugLine="Sub SetEditTextHeight(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 200;BA.debugLine="If NewHeight < OldHeight Then";
if (_newheight<_oldheight) { 
 //BA.debugLineNum = 201;BA.debugLine="etTest.Height = NewHeight - (4%y + btnChangeKb.H";
mostCurrent._ettest.setHeight((int) (_newheight-(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (4),mostCurrent.activityBA)+mostCurrent._btnchangekb.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)))));
 //BA.debugLineNum = 202;BA.debugLine="eventstring = eventstring & \"KB_HCV , \"";
_v7 = _v7+"KB_HCV , ";
 }else if(_newheight>_oldheight) { 
 //BA.debugLineNum = 204;BA.debugLine="etTest.Height = 70%y";
mostCurrent._ettest.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (70),mostCurrent.activityBA));
 //BA.debugLineNum = 205;BA.debugLine="eventstring = eventstring & \"KB_HCG , \"";
_v7 = _v7+"KB_HCG , ";
 };
 //BA.debugLineNum = 207;BA.debugLine="End Sub";
return "";
}
public static String  _v6(String _startkeyboard) throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub SetEditTextParams(StartKeyboard As String)";
 //BA.debugLineNum = 83;BA.debugLine="Select Case StartKeyboard";
switch (BA.switchObjectToInt(_startkeyboard,"nrkeyboard","ipkeyboard","fullnrkeyboard","hexkeyboard","standard","neverregistered")) {
case 0:
 //BA.debugLineNum = 85;BA.debugLine="etTest.Text = \"This editbox now accepts only de";
mostCurrent._ettest.setText((Object)("This editbox now accepts only decimal numbers & two cursor keys"));
 break;
case 1:
 //BA.debugLineNum = 87;BA.debugLine="etTest.Text = \"This editbox now accepts only de";
mostCurrent._ettest.setText((Object)("This editbox now accepts only decimal numbers & the dot & delete & four cursor keys"));
 break;
case 2:
 //BA.debugLineNum = 89;BA.debugLine="etTest.Text = \"This editbox now accepts only de";
mostCurrent._ettest.setText((Object)("This editbox now accepts only decimal numbers & delete & CRLF & six cursor keys & space & clear"));
 break;
case 3:
 //BA.debugLineNum = 91;BA.debugLine="etTest.Text = \"This editbox now accepts only HE";
mostCurrent._ettest.setText((Object)("This editbox now accepts only HEX-numbers & four cursor keys"));
 break;
case 4:
 //BA.debugLineNum = 93;BA.debugLine="etTest.Text = \"This editbox now accepts all ASC";
mostCurrent._ettest.setText((Object)("This editbox now accepts all ASCII text"));
 break;
case 5:
 //BA.debugLineNum = 95;BA.debugLine="etTest.Text = \"This editbox was never registere";
mostCurrent._ettest.setText((Object)("This editbox was never registered and accepts all ASCII text"));
 break;
}
;
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
}
